#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright (c) 2008 Nacho Molina. All rights reserved.
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License as published
# by the Free Software Foundation, either version 2 of the License, or
# version 3 of the License, or (at your option) any later version. It is
# provided for educational purposes and is distributed in the hope that
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
# the GNU General Public License for more details.

from __future__ import division
import functools
import random
import sys
import os
import tarfile
import shutil
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from modules.textItem import *
from modules.authorDlg import *
from modules.classes import *
from modules.const import *
from modules.about import *
from modules.wizard import *

PointSize = 10

MagicNumber = 0x70616765
FileVersion = 1

Dirty = False
home = QDir.homePath()
temp = QDir.tempPath()+"/KS"
ACTDIR=os.path.abspath(sys.path[0])

class GraphicsView(QGraphicsView):
    def __init__(self, parent=None):
        super(GraphicsView, self).__init__(parent)
        self.setDragMode(QGraphicsView.RubberBandDrag)
        self.setRenderHint(QPainter.Antialiasing)
        self.setRenderHint(QPainter.TextAntialiasing)

class MainForm(QMainWindow):
    def __init__(self, parent=None):
        super(MainForm, self).__init__(parent)
        print ACTDIR
        if os.path.exists(str(temp)):pass
        else:os.mkdir(temp)
        apsize = 806,708
        self.resize(apsize[0],apsize[1])
        self.setMinimumSize(apsize[0],apsize[1])
        self.setMaximumSize(apsize[0],apsize[1])
        self.filename = QString()
        self.ultimodir = QString()
        self.copiedItem = QByteArray()
        self.pasteOffset = 5
        self.prevPoint = QPoint()
        self.addOffset = 5
        self.pixcons = []
        self.txt = []
        self.recentFiles = []
        self.process = QProcess()
        self.basura = []
        MaxRecentFiles = 5
        self.n = 40
        back = None
        
# Menus y Toolbar
        self.new = QAction(QIcon('%s/images/filenew.png' %ACTDIR), self.tr('New ...'), self)
        self.new.setShortcut('Ctrl+N')
        self.new.setStatusTip(self.tr('Create a new Splash Screen.'))
        self.connect(self.new, SIGNAL('triggered()'), self.newSplash)
        
        self.opfile = QAction(QIcon('%s/images/fileopen.png' %ACTDIR), self.tr('Open .gz...'), self)
        self.opfile.setShortcut('Ctrl+O')
        self.opfile.setStatusTip(self.tr('Open compressed Splash Screen Theme file.'))
        self.connect(self.opfile, SIGNAL('triggered()'), self.openGZ)

        self.opdir = QAction(QIcon('%s/images/fileopendir.png' %ACTDIR), self.tr('Open Dir ...'), self)
        self.opdir.setShortcut('Ctrl+D')
        self.opdir.setStatusTip(self.tr('Open directory containing an uncompressed Splash Screen Theme.'))
        self.connect(self.opdir, SIGNAL('triggered()'), self.openDir)

        self.save = QAction(QIcon('%s/images/filesave.png' %ACTDIR), self.tr('Save .gz'), self)
        self.save.setShortcut('Ctrl+S')
        self.save.setStatusTip(self.tr('Save compressed Splash Screen Theme file.'))
        self.connect(self.save, SIGNAL('triggered()'), self.SaveGZ)
        self.save.setEnabled(False)
        
        self.saveas = QAction(QIcon('%s/images/filesaveas.png' %ACTDIR), self.tr('Save as ...'), self)
        self.saveas.setStatusTip(self.tr('Save compressed Splash Screen Theme using a new name.'))
        self.connect(self.saveas, SIGNAL('triggered()'), self.SaveAsGZ)
        self.saveas.setEnabled(False)
        
        self.savedir = QAction(QIcon('%s/images/filesavedir.png' %ACTDIR), self.tr('Save Dir ...'), self)
        self.savedir.setStatusTip(self.tr('Save changes into a dir for manual editing.'))
        self.connect(self.savedir, SIGNAL('triggered()'), self.SaveDir)
        self.savedir.setEnabled(False)

        self.recentList = QMenu()
        self.recentList.setTitle(self.tr("Recent ..."))
        self.recentList.setIcon(QIcon('%s/images/adicon.png' %ACTDIR))
        self.recentList.clear()
        self.recentList.setEnabled(False)
          
        self.chback = QAction(QIcon('%s/images/chback.png' %ACTDIR), self.tr('Background ...'), self)
        self.chback.setShortcut('Ctrl+B')
        self.chback.setStatusTip(self.tr('Change background image of current theme.'))
        self.connect(self.chback, SIGNAL('triggered()'), self.chgBack)
        self.chback.setEnabled(False)

        self.adicon = QAction(QIcon('%s/images/adicon.png' %ACTDIR), self.tr('Icon ...'), self)
        self.adicon.setShortcut('Ctrl+I')
        self.adicon.setStatusTip(self.tr('Add a new icon to your theme.'))
        self.connect(self.adicon, SIGNAL('triggered()'), self.addPixmap)
        self.adicon.setEnabled(False)

        self.adtext = QAction(QIcon('%s/images/adtext.png' %ACTDIR), self.tr('Text ...'), self)
        self.adtext.setShortcut('Ctrl+T')
        self.adtext.setStatusTip(self.tr('Add text labels to your theme.'))
        self.connect(self.adtext, SIGNAL('triggered()'), self.addText)
        self.adtext.setEnabled(False)

        self.pre = QAction(QIcon('%s/images/pre.png' %ACTDIR), self.tr('Preview'), self)
        self.pre.setStatusTip(self.tr('Create a preview image for use with your theme.'))
        self.connect(self.pre, SIGNAL('triggered()'), self.preview)
        self.pre.setEnabled(False)

        self.bye = QAction(QIcon('%s/images/filequit.png' %ACTDIR), self.tr('Exit'), self)
        self.bye.setShortcut('Ctrl+Z')
        self.bye.setStatusTip(self.tr('Exit application'))
        self.connect(self.bye, SIGNAL('triggered()'), self.accept)

        self.auth = QAction(QIcon('%s/images/author.png' %ACTDIR), self.tr('Author Info ...'), self)
        self.auth.setShortcut('Ctrl+A')
        self.auth.setStatusTip(self.tr('Change basic info about the author of the theme.'))
        self.connect(self.auth, SIGNAL('triggered()'), self.chAuthor)
        self.auth.setEnabled(False)

        self.alx = QAction(QIcon('%s/images/alx.png' %ACTDIR), self.tr('Align X ...'), self)
        self.alx.setShortcut('Ctrl+X')
        self.alx.setStatusTip(self.tr('Align icons at X position of the first icon.'))
        self.connect(self.alx, SIGNAL('triggered()'), self.alignx)
        self.alx.setEnabled(False)

        self.aly = QAction(QIcon('%s/images/aly.png' %ACTDIR), self.tr('Align Y ...'), self)
        self.aly.setShortcut('Ctrl+Y')
        self.aly.setStatusTip(self.tr('Align icons at Y position of the first icon.'))
        self.connect(self.aly, SIGNAL('triggered()'), self.aligny)
        self.aly.setEnabled(False)

        self.test = QAction(QIcon('%s/images/test.png' %ACTDIR), self.tr('Test ...'), self)
        self.test.setShortcut('F5')
        self.test.setStatusTip(self.tr('Test your Splash Theme.'))
        self.connect(self.test, SIGNAL('triggered()'), self.TestSplash)
        self.test.setEnabled(False)

        self.about = QAction(QIcon('%s/images/about.png' %ACTDIR), self.tr('About ...'), self)
        self.about.setShortcut('F1')
        self.about.setStatusTip(self.tr('About KSplasher...'))
        self.connect(self.about, SIGNAL('triggered()'), self.aboutDialog)
        
        menubar = self.menuBar()
        ar = menubar.addMenu(self.tr('&File'))
        ar.addAction(self.new)
        ar.addAction(self.opfile)
        ar.addAction(self.opdir)
        ar.addAction(self.save)
        ar.addAction(self.saveas)
        ar.addAction(self.savedir)
##        ar.addSeparator()
##        ar.addMenu(self.recentList)
        ar.addSeparator()
        ar.addAction(self.bye)
        
        edit = menubar.addMenu(self.tr('&Edit Theme'))
        edit.addAction(self.chback)
        edit.addAction(self.adicon)
        edit.addAction(self.adtext)
        edit.addAction(self.pre)

        author = menubar.addMenu(self.tr('&Modify'))
        author.addAction(self.auth)
        author.addAction(self.alx)
        author.addAction(self.aly)

        about = menubar.addMenu(self.tr('&Help'))
        about.addAction(self.about)
        
        toolbar = self.addToolBar(self.tr('File'))
        toolbar.setMovable (False)
        toolbar.setIconSize(QSize(24,24))
        toolbar.setToolButtonStyle(Qt.ToolButtonTextUnderIcon)
        toolbar.addAction(self.new)
        toolbar.addAction(self.opfile)
        toolbar.addAction(self.opdir)
        toolbar.addAction(self.save)
        toolbar.addAction(self.saveas)
        toolbar.addAction(self.savedir)
        
        toolbar2 = self.addToolBar(self.tr('Edit Theme'))
        toolbar2.setMovable (False)
        toolbar2.setIconSize(QSize(24,24))
        toolbar2.setToolButtonStyle(Qt.ToolButtonTextUnderIcon)
##        toolbar2.addAction(self.chback)
##        toolbar2.addAction(self.adicon)
##        toolbar2.addAction(self.adtext)
##        toolbar2.addAction(self.pre)
        toolbar2.addSeparator()
        toolbar2.addAction(self.auth)
        toolbar2.addAction(self.alx)
        toolbar2.addAction(self.aly)
        toolbar2.addSeparator()
        toolbar2.addAction(self.test)
##        toolbar2.addAction(self.bye)

# status bar + real size
        self.sizeLabel = QLabel()
        self.sizeLabel.setFrameStyle(QFrame.StyledPanel|QFrame.Sunken)
        self.status = self.statusBar()
        self.status.setSizeGripEnabled(False)
        self.status.addPermanentWidget(self.sizeLabel)     
        self.status.showMessage(self.tr("Ready"), 5000)

# center prefs.

        self.view = GraphicsView()
        self.scene = QGraphicsScene(self)
        self.scene.setSceneRect(0, 0, 800, 600)       
        self.view.setCacheMode(QGraphicsView.CacheBackground)        
        self.view.setScene(self.scene)

# below we create the main form layout with the widgets

        self.setWindowTitle(self.tr("KSplasher 2.0 beta 1"))
        self.setWindowIcon(QIcon('%s/images/ksicon.png' %ACTDIR))
        self.setCentralWidget(self.view)

    def Prueba(self):
        QMessageBox.warning(self, "KSplasher -- PRUEBA",
                    "PRUEBA")
    def newSplash(self):
        dialog = NewWizard(ACTDIR, parent=self)
        dialog.exec_()
        self.cargar(str(temp+"/NEW"))

        self.save.setEnabled(True)
        self.saveas.setEnabled(True)
        self.savedir.setEnabled(True)
        self.chback.setEnabled(True)
        self.auth.setEnabled(True)
        self.alx.setEnabled(True)
        self.aly.setEnabled(True)
        self.pre.setEnabled(True)
        self.test.setEnabled(True)


    def TestSplash(self):
        fname = home+"/.kde/share/apps/ksplash/Themes/"+self.a.datos[0]
        if os.path.exists(str(fname)):
            shutil.rmtree(str(fname))
            try:self.basura.remove(fname)
            except:pass
        self.guardar()
        os.mkdir(str(fname))
        self.basura.append(fname)
        for root, dirs, files in os.walk(str(self.ruta)):
            for name in files:
                shutil.copy(os.path.join(str(root), str(name)),str(fname))
        
        comando = "ksplash --test --theme "+self.a.datos[0]
        self.process.start(str(comando))
        
    def openRecentFile(self):
        action = self.sender()
        if action:
            print action
        
    def aboutDialog(self):
        dialog = AboutDlg(ACTDIR, parent=self)
        dialog.exec_()
        
    def reject(self):
        self.accept()


    def accept(self):
        self.offerSave()
        self.clean()
        self.close()

    def clean(self):
        print self.basura
        if not len(self.basura)==0:
            for caca in self.basura:
                shutil.rmtree(str(caca))
        else:pass
        shutil.rmtree(str(temp))

    def offerSave(self):
        if Dirty and QMessageBox.question(self,
                            self.tr("KSplasher - Unsaved Changes"),
                            self.tr("Save unsaved changes?"),
                            QMessageBox.Yes|QMessageBox.No) == \
           QMessageBox.Yes:
            self.SaveGZ()

    def position(self):
        point = self.mapFromGlobal(QCursor.pos())
        if not self.view.geometry().contains(point):
            coord = random.randint(36, 144)
            point = QPoint(coord, coord)
        else:
            if point == self.prevPoint:
                point += QPoint(self.addOffset, self.addOffset)
                self.addOffset += 5
            else:
                self.addOffset = 5
                self.prevPoint = point
        return self.view.mapToScene(point)

    def openGZ(self):
        self.filename.clear()
        self.offerSave()
        path = self.ultimodir \
            if not self.ultimodir.isEmpty() else home
        fname = QFileDialog.getOpenFileName(self,
                            self.tr("KSplasher - Open .tar.gz file"), path,
                            self.tr("Compressed Files (*.tar *.gz *.bz2 *.z)"))
        if fname.isEmpty(): return
        else: self.ultimodir = QFileInfo(fname).path()
        
        control=0
        try:
            tar = tarfile.open(str(fname))
            tar.extractall(str(temp))
            for tarinfo in tar:
                if tarinfo.isdir():
                    rut=tarinfo.name
                if os.path.basename(tarinfo.name)=='Theme.rc' or os.path.basename(tarinfo.name)=='theme.rc':
                    control=1
            if control:
                self.cargar("%s/%s" %(str(temp),rut.strip("/")))
#                self.cargar(os.path.join(str(temp),rut.strip("/")))
            else:
                QMessageBox.warning(self, self.tr("KSplasher - Invalid File"),
                    self.tr('The file "%s" is not a Splash Theme File')
                                %os.path.basename(str(fname)))
                return
        except:
            QMessageBox.warning(self, self.tr("KSplasher - Not Compressed"),
                    self.tr('The file "%s" is not a compressed file')
                                %os.path.basename(str(fname)))
            return
        
        self.filename = fname
        self.status.showMessage(str(self.tr('File "%s" loaded')) %os.path.basename(str(fname))
                                , 5000)
        
        self.save.setEnabled(True)
        self.saveas.setEnabled(True)
        self.savedir.setEnabled(True)
        self.chback.setEnabled(True)
        self.auth.setEnabled(True)
        self.alx.setEnabled(True)
        self.aly.setEnabled(True)
        self.pre.setEnabled(False)
        self.test.setEnabled(True)
        
    def openDir(self):
        self.filename.clear()
        self.offerSave()
        path = self.ultimodir \
            if not self.ultimodir.isEmpty() else home
        fname = QFileDialog.getExistingDirectory(self,
                            self.tr("KSplasher - Open Directory"), path, QFileDialog.ShowDirsOnly
                                                 | QFileDialog.DontResolveSymlinks)
        if fname.isEmpty(): return
        else: self.ultimodir = fname
        self.cargar(fname)
        self.status.showMessage(str(self.tr('Directory "%s" loaded')) %os.path.basename(str(fname)), 5000)

        self.save.setEnabled(True)
        self.saveas.setEnabled(True)
        self.savedir.setEnabled(True)
        self.chback.setEnabled(True)
        self.auth.setEnabled(True)
        self.alx.setEnabled(True)
        self.aly.setEnabled(True)
        self.pre.setEnabled(True)
        self.test.setEnabled(True)
        
    def cargar(self, fname):
        self.pixcons = []
        self.txt = []
        items = self.scene.items()
        self.ruta = fname
        while items:
            item = items.pop()
            self.scene.removeItem(item)
            del item
            
        if os.path.exists("%s/Theme.rc" %fname):
            self.a=Generar(ACTDIR,"%s/Theme.rc" %fname, fname)
        elif os.path.exists("%s/theme.rc" %fname):
            self.a=Generar(ACTDIR,"%s/theme.rc" %fname, fname)
        else:
            QMessageBox.warning(self, self.tr("KSplasher - Invalid Directory"),
                    self.tr('The directory "%s" is not a Splash Theme Dir')
                                %os.path.basename(str(fname)))
            return

        if os.path.exists("%s/Background.jpg" %fname):
            back = QPixmap("%s/Background.jpg" %fname)
        elif os.path.exists("%s/Background.png" %fname):
            back = QPixmap("%s/Background.png" %fname)
        else:
            QMessageBox.warning(self, self.tr("KSplasher - Invalid Background"),
                    self.tr("Your theme doesn't have a background image"))
            back = QPixmap()
            return

        self.view.setBackgroundBrush(QBrush(QPixmap.scaledToWidth(back,800)))
        self.ancho,self.alto = back.width(),back.height()
        per = 800/back.width()
        self.per = per
        self.sizeLabel.setText("%d x %d" % (back.width(), back.height()))

#Llenamos la pantalla
        j = 0
        while j in range(len(self.a.iconos)):
            for i in self.a.coordenadas:
                x,y = i.split(",")
                x,y = int(x)*per,int(y)*per
                pix = QPixmap(self.a.iconos[j])
                wid = pix.width()*per
                self.createPixmapItem(QPixmap.scaledToWidth(pix,wid),
                                      self.view.mapToScene(QPoint(x,y+2)))
                j = j+1

# LABELS
        j = 0
        while j in range(len(self.a.lab)):
            menso,fu,coor,col=self.a.lab[j]
            try:
                x,y = coor.split(",")
                x,y = int(x)*per,int(y)*per
                try:
                    lab_ta=fu.split(",")#Fuente,Tamano,??,Color?(RGB)
                    ta=int(lab_ta[1])
                except:ta=15
                if col=='': col=QColor(255,255,255,255)
                else:
                    col_tmp=col.split(',')
                    col=QColor(int(col_tmp[0]),int(col_tmp[1]),
                               int(col_tmp[2]),255)
                if menso=='ML:USER:loginname': menso='guest'
                elif menso=='ML:CMD:date': menso='Wed Apr 28 04:55:49 MDT 2008'
                txt = TextItem(menso,col,self.view.mapToScene(QPoint(x,y)),
                         self.scene,font=QFont(str(fu), ta*per))
                self.txt.append(txt)
            except:pass
            j=j+1
# STATUS
        try:
            x,y=self.a.stat[0].split(",")#coordenadas
            x,y = (int(x)),int(y.strip("\n"))
            if x < 0:
                x = ((back.width()/2)-100)
            stat_coord=1
        except:stat_coord=0
        try:
            stat_col=self.a.stat[1].split(",")#Fuente,Tamano,??,Color?(RGB)
            fu=stat_col[0]
            ta=int(stat_col[1])
        except:ta=15
        if stat_coord:
            self.stat = TextItem("KDE is up and running",QColor(255,255,255,255),
                     self.view.mapToScene(QPoint(x*per,y*per+2)),
                     self.scene,font=QFont(str(fu), ta*per))
         
    def addText(self):
        dialog = TextItemDlg(position=self.position(),
                             scene=self.scene, parent=self)
        dialog.exec_()

    def chAuthor(self):
        dialog = AuthorDlg(self.a.datos, ACTDIR, parent=self)
        dialog.exec_()

    def addPixmap(self):
        path = QFileInfo(self.filename).path() \
            if not self.filename.isEmpty() else "."
        fname = QFileDialog.getOpenFileName(self,
                            self.tr("KSplasher - Add/Change Icon"), path,
                            self.tr("Pixmap Files (*.bmp *.jpg *.png *.xpm)"))
        if fname.isEmpty():
            return
        self.createPixmapItem(QPixmap(fname), self.position())

        global Dirty
        Dirty = True

    def chgBack(self):
        path = QFileInfo(self.filename).path() \
            if not self.filename.isEmpty() else "."
        fname = QFileDialog.getOpenFileName(self,
                            self.tr("KSplasher - Add/Change Background"), path,
                            self.tr("Pixmap Files (*.bmp *.jpg *.png *.xpm)"))
        if fname.isEmpty():
            return
        img = QImage(fname)
        img2 = img.scaled(self.ancho,self.alto)
        if os.path.exists("%s/Background.jpg" %str(self.ruta)):
            os.remove(os.path.join(str(self.ruta),'Background.jpg'))
        elif os.path.exists("%s/Background.png" %str(self.ruta)):
            os.remove(os.path.join(str(self.ruta),'Background.png'))
        img2.save(os.path.join(str(self.ruta),'Background.jpg'))
        self.view.setBackgroundBrush(QBrush(QPixmap.scaledToWidth(QPixmap(fname),800)))
        
        global Dirty
        Dirty = True

    def createPixmapItem(self, pixmap, position, matrix=QMatrix()):
        item = QGraphicsPixmapItem(pixmap)
        item.setFlags(QGraphicsItem.ItemIsSelectable|
                      QGraphicsItem.ItemIsMovable)
        item.setPos(position)
        item.setMatrix(matrix)
        self.scene.clearSelection()
        self.scene.addItem(item)        
        item.setSelected(True)
        self.pixcons.append(item)
        
        global Dirty
        Dirty = True        

    def selectedItem(self):
        items = self.scene.selectedItems()
        if len(items) == 1:
            return items[0]
        return None

    def alignx(self):
        self.setAlignment(Qt.AlignBottom)
        
    def aligny(self):
        self.setAlignment(Qt.AlignLeft)

    def setAlignment(self, alignment):
        items = self.pixcons
        if len(items) <= 1:
            return
        index = 0
        rect = items[index].sceneBoundingRect()
        # Find how much the other items must move by
        dialog = QInputDialog.getInteger(self, self.tr("Align Spacing"),
                                    self.tr("Spacing (in pixels):"), self.n, 0, 100, 1)
        self.n = dialog[0]
        n = self.n
        for i, item in enumerate(items):
            if i == index:
                item.setSelected(True)
                continue
            itemrect = item.sceneBoundingRect()
            xOffset = yOffset = 0
            if alignment == Qt.AlignLeft:
                xOffset = rect.x() - itemrect.x()
                yOffset = rect.y() - itemrect.y() + n
##            elif alignment == Qt.AlignRight:
##                xOffset = (rect.x() + rect.width()) - \
##                          (itemrect.x() + itemrect.width())
##            elif alignment == Qt.AlignTop:
##                yOffset = rect.y() - itemrect.y()
            elif alignment == Qt.AlignBottom:
                xOffset = rect.x() - itemrect.x() + n
                yOffset = (rect.y() + rect.height()) - \
                          (itemrect.y() + itemrect.height())
            item.moveBy(xOffset, yOffset)
            item.setSelected(True)
            n = n + self.n
        global Dirty
        Dirty = True

##    def delete(self):
##        items = self.scene.selectedItems()
##        if len(items) and QMessageBox.question(self,
##                "KSplasher - Delete",
##                "Delete %d item%s?" % (len(items),
##                "s" if len(items) != 1 else ""),
##                QMessageBox.Yes|QMessageBox.No) == QMessageBox.Yes:
##            while items:
##                item = items.pop()
##                self.scene.removeItem(item)
##                del item
##            global Dirty
##            Dirty = True

    def preview(self):
        img=QImage(512,384,QImage.Format_RGB32)
        self.scene.clearSelection()
        painter=QPainter(img)
        self.view.render(painter)
        painter.end()
        img.save(os.path.join(str(self.ruta),'preview.png'))

    def SaveDir(self):
        path = home \
            if not self.filename.isEmpty() else str(self.ruta)
        fname = QFileDialog.getExistingDirectory(self,
                            self.tr("KSplasher - Save Directory"), path, QFileDialog.ShowDirsOnly
                                                 | QFileDialog.DontResolveSymlinks)

        if fname.isEmpty(): return
        elif fname == self.ruta: pass
        else:
            for root, dirs, files in os.walk(str(self.ruta)):
                for name in files:
                    shutil.copy(os.path.join(str(root), str(name)),str(fname))

            self.ruta = fname
        self.guardar()
            
    def guardar(self):
# guardamos el .rc con la info de las coordenadas
        self.preview()
        ta=file((os.path.join(str(self.ruta),'Theme.rc')),'w')

        for i in Datos:
            self.a.RC[i]=self.a.datos[Datos[i]]

        ii='[KSplash Theme'
        self.a.RC[ii]=' '+self.a.datos[0]+']'

        items = self.pixcons
        for i, item in enumerate(items):
            self.a.coordenadas[i] = int(item.x()/self.per),int(item.y()/self.per)

        for i in Coord:
            try: # Ingresamos las coordenadas actuales al diccionario de coordenadas
                self.a.RC[i]=(str(self.a.coordenadas[Coord[i]]).strip('(')).strip(')')
            except: pass
            
        try:# Ingresamos coordenadas del status
            xy = int(self.stat.x()/self.per),int(self.stat.y()/self.per)
            self.a.RC['StatusCoords'] = (str(xy).strip('(')).strip(')')
        except: pass

        txts = self.txt
        for i, item in enumerate(txts):
            self.a.lab[i] = int(item.x()/self.per),int(item.y()/self.per)

        for i in Labels:
            try:
                self.a.RC[Labels[i][3]]=(str(self.a.lab[Labels[i][0]]).strip('(')).strip(')')
            except:pass
            
        for i in RC_ORD:
            try:
                self.a.RC[i] # vemos si existe la descripcion en el diccionario "RC"
                if i=='[KSplash Theme':
                    ta.write(i+':'+self.a.RC[i]+'\n')# Generamos el archivo .RC
                else: ta.write(i+'='+self.a.RC[i]+'\n')# Generamos el archivo .RC
            except: pass
            
        global Dirty
        Dirty = False

    def SaveAsGZ(self):
        self.filename.clear()
        self.SaveGZ()
        
    def SaveGZ(self):
        self.guardar()
        if self.filename.isEmpty():
            path = home
            fname = QFileDialog.getSaveFileName(self,
                                self.tr("KSplasher - Save As"), path,
                                self.tr("Compressed Files (*.tar.gz)"))
            if fname.isEmpty(): return
            else: self.filename = fname
        tar = tarfile.open(str(self.filename),"w:gz")
        tar.add(str(self.ruta),self.a.datos[0])#os.path.basename(str(self.ruta)))
        tar.close()
        self.status.showMessage(str(self.tr('File "%s" saved.')) %os.path.basename(str(self.filename)), 5000)
        
        global Dirty
        Dirty = False

def setupTranslator(app):
    translator = QTranslator(app)
    lng = str(QLocale.system().name()).split("_")[0]
    translator.load("%s/lang/%s.qm" %(ACTDIR,str(lng)))
    app.installTranslator(translator)


class Inicio(QApplication):
    """Splash + Main Window"""
    def __init__(self,args=None):

        QApplication.__init__(self,args)
        setupTranslator(self)
        pixmap = QPixmap("images/logo.png",'png')
        self.splash = QSplashScreen(pixmap,Qt.WindowStaysOnTopHint)
        self.splash.show()
        QTimer.singleShot(2000,self.splash,SLOT("hide()"))
        self.mywindow = MainForm()
        self.mywindow.show()
        self.exec_()

if __name__ == "__main__":
#    app = QApplication(sys.argv)
#    setupTranslator(app)
#    form = MainForm()
#    form.show()
#    app.exec_()
    app = Inicio(sys.argv)

    

